/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        $.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);
        
        //Set default values
        oComponent.addParamVal("name", _D("Consumption Info"));
        oComponent.addParamVal("knx-write-address","//");
        oComponent.addParamVal("knx-feedback-address","//");
        oComponent.addParamVal("knx/virtual-feedback",false);
    };
}
catch(err){
    console.error(err);
}
