﻿/*####################
### COMMON METHODS ###
###   22/02/2013   ###
####################*/
"use strict";
/*
//Compare function (for Array comparing)
function compareById(a,b)
{
  if (a.id < b.id)
     return -1;
  if (a.id > b.id)
    return 1;
  return 0;
}
function compareByPid(a,b)
{
	if(a.pid < b.pid){	return -1;	}
	if(a.pid > b.pid){	return 1;	}
		return 0;
}
*/
/*
	Return first free id reading id attribute from an array of objects.
	Common method strIdNumb() is used (in common_methods.js).
	
	Return first free id number.

function idAssign(iArray,param)
{
	param = param || "id";		//Default comparison parameter
	var start_id_numb = 0;		//Start Id number
	var FREE = false,			//Loop counter
		count = 0;
	
	console.log(arguments)
	
	//Debug check
	if(!iArray instanceof Array){
		console.warn("Warning: input parameter isn't an instance of Array")
		return;
	}
	
	//Find first free id
	while(!FREE && count < iArray.length){
		FREE = true;
		count ++;
		for(var i = 0; i < iArray.length; ++i){
			if(start_id_numb == iArray[i][param].strIdNumb()){
				start_id_numb++;
				FREE = false;
				break;
			}
		}
	}
	return start_id_numb;
}*/

/*
Build file via php calling "file_builder.php" (jquery used)
	fDir -> File detinations string (in according with file_builder.php position);
	fName -> File name string;
	fCont -> File content string;
	fExt -> File extention string (optional, set to null in case of next parameter needed);
	cbFunc -> Call back function (optional);

function buildFile(fDir,fName,fCont,fExt,cbFunc)
{
	//Default extention value
	fExt = (fExt == null || fExt == "" || fExt == undefined) ? "" : fExt;
	//Default CallBack function
	cbFunc = (cbFunc == null || cbFunc == "" || cbFunc == undefined) ? function(){ return; } : cbFunc;
	//File builder Ajax call
	$.ajax({
		type: "POST",
		//Attention: check file_builder.php position
		url:"./php/file_builder.php",
		data: { path: fDir, name: fName, cont: fCont, ext:fExt },
		cache: false,
		success: function(msg){
			if(msg == "error"){
				if(CONSOLLE){ CONSOLLE.writeLine("Error: file can't be write",2); }
				else{ alert("Error: file can't be write"); }
				msg = "";
				return false;
			}
			cbFunc(msg);
			return msg;
		},
		error: function(jqXHR, textStatus, errorThrown){
			CONSOLLE.writeLine('HTTP Error: '+errorThrown+' | Error Message: '+textStatus,"ERROR");
			 if(CONSOLLE){ CONSOLLE.writeLine('HTTP Error: '+errorThrown+' | Error Message: '+textStatus,2); }
			 else{ alert('HTTP Error: '+errorThrown+' | Error Message: '+textStatus); }
			 return false;
		}
	});
}*/
/*
Upload file via php calling "upload.php" (jquery used)
	fFormData	-> Form element that contain input type file (or more file inputs);
	fDir		-> File detinations string (in according with upload.php position, default "../config/upload") (optional);
	fType		-> Accept extention, string separated by spaces (eg. png jpg ...) (optional);
	cbFunc		-> Call back function (optional);

function uploadFile(fForm,fDir,fType,cbFunc){
	//Check error
	if(!(fForm instanceof HTMLFormElement)){
		if(CONSOLLE != undefined && CONSOLLE instanceof Consolle){
			CONSOLLE.writeLine("Error: object \"fForm\" in input isn't an instance of HTMLFormElement, [function uploadFile]",2);
		}
		else{
			alert("Error: object \"fForm\" in input isn't an instance of HTMLFormElement, [function uploadFile]");	
		}
	}
	//Check input type file existance warning
	if($(fForm).find("input[type='file']").length < 1){
		if(CONSOLLE != undefined && CONSOLLE instanceof Consolle){
			CONSOLLE.writeLine("Warning: object \"fForm\" don't contain any type file input, [function uploadFile]",1);
		}
		else{
			alert("Warning: object \"fForm\" don't contain any type file input, [function uploadFile]");	
		}
	}
	//Default directory value
	fDir = (fDir == null || fDir == "" || fDir == undefined) ? "../config/upload" : fDir;
	//Default CallBack function
	cbFunc = (cbFunc == null || cbFunc == "" || cbFunc == undefined) ? function(){ return; } : cbFunc;
	//Form data variable
	var formData = new FormData(fForm);
	//fForm.append("dir",)
	if(formData.append != undefined){ CONSOLLE.writeLine("Exist",3); }
	else{ CONSOLLE.writeLine("Not Exsist",2); }
	//for(var k in formData) CONSOLLE.writeLine(k);
	//File upload Ajax call
	return;
	$.ajax({
		type: "POST",
		//Attention: check file_builder.php position
		url:"./php/file_builder.php",
		data: { path: fPath, name: fName, cont: fCont, ext:fExt },
		cache: false,
		success: function(msg){
			if(msg == "error"){
				alert("Error: file can't be write");
				msg = "";
				return false;
			}
			cbFunc(msg);
			return msg;
		},
		error: function(jqXHR, textStatus, errorThrown){
			 alert('HTTP Error: '+errorThrown+' | Error Message: '+textStatus);
			 return false;
		}
	});
}
*/
/*
Log error via php calling "file_builder.php"
	fName -> File name string;
	fCont -> File content string;
	fExt -> File extention string (optional, set to html in case of next parameter needed);
*/
function logError(fName,fCont,fExt)
{
	//Methods properties
	this.success	= function(resp){};
	this.error		= function(resp){};
	this.complete	= function(resp){};
	//Default extention value as html (working in a web server)
	fExt = (fExt == null || fExt == "" || fExt == undefined) ? "html" : fExt;
	//File builder Ajax call
	$.ajax({
		type: "POST",
		//Attention: check file_builder.php position
		url:"./php/file_builder.php",
		data: { path: "../log", name: fName, cont: fCont, ext:fExt },
		cache: false,
		success: function(msg){
			if(msg == "error"){
				error("Error: file can't be write");
				msg = "";
				return false;
			}
			success(msg);
			return msg;
		},
		error: function(jqXHR,textStatus,errorThrown){
			error('HTTP Error: '+errorThrown+' | Error Message: '+textStatus);
			return false;
		},
		complete: function(msg){ complete(msg); }
	});
}


/*############
### String ###
############*/

/*
Capitalize first letter of a string

Output:
String

String.prototype.upperCaseFirst = function(){ return this.charAt(0).toUpperCase() + this.slice(1); }*/

/*
DA UN NOME GENERICO CON UN NUMERO FINALE (ES. PIPPO32), ESTRAE E RITORNA LA CIFRA FINALE
(CHECK PROTOTYPE FUNCTION)

String.prototype.strIdNumb = function()
{
	//Check string validity
	if(this.length < 1){ return false; }
	var FIND				=	false,				// Find number
		numbers				=	"1234567890",		// All number string
		indexFirstNumb		=	this.length - 1,	// Number finder index
		firstPosition;								// Fisrt position number
	while(!FIND && indexFirstNumb > 0){
		if(numbers.indexOf(this.charAt(indexFirstNumb)) != -1){
			firstPosition	= indexFirstNumb;
			indexFirstNumb	= indexFirstNumb - 1;
		}
		else{ FIND = true; }
	}
	return parseInt(this.substring(firstPosition,this.length),10);
}
*/
/*
DA UN NOME GENERICO CON UN NUMERO FINALE (ES. PIPPO32), ESTRAE E RITORNA IL
NOME SENZA IL NUMERO FINALE

String.prototype.baseName = function()
{
	//Check string validity
	if(this.length < 1){ return false; }
	var FIND				=	false,				// Find number
		numbers				=	"1234567890",		// All number string
		indexFirstNumb		=	this.length - 1,	// Number finder index
		firstPosition;								// Fisrt position number
	while(!FIND && indexFirstNumb > 0){
		if(numbers.indexOf(this.charAt(indexFirstNumb)) != -1){
			firstPosition = indexFirstNumb;
			indexFirstNumb = indexFirstNumb - 1;
		}
		else
			FIND = true;
	}
	return this.substring(0,firstPosition);//,this.length);
}*/

/*
Convalidate e-mail

Input:
cbFunc		->	callback function			[function]	(called at invalid e-mail event)

Output:
bolean		->	confirm is ok

String.prototype.mailCheck = function(cbFunc)
{
	cbFunc = cbFunc || function(){ alert("Invalid E-mail ID"); };
	var at="@",
		dot=".",
		lat=this.indexOf(at),
		lstr=this.length,
		ldot=this.indexOf(dot);
	if(this.indexOf(" ")!=-1)
	{ cbFunc(); return false; }
	if(this.indexOf(at)==-1)
	{ cbFunc(); return false; }
	if(this.indexOf(at)==-1 || this.indexOf(at)==0 || this.indexOf(at)==lstr)
	{ cbFunc(); return false; }
	if(this.indexOf(dot)==-1 || this.indexOf(dot)==0 || this.indexOf(dot)==lstr)
	{ cbFunc(); return false; }
	if(this.indexOf(at,(lat+1))!=-1)
	{ cbFunc(); return false; }
	if(this.substring(lat-1,lat)==dot || this.substring(lat+1,lat+2)==dot)
	{ cbFunc(); return false; }
	if(this.indexOf(dot,(lat+2))==-1)
	{ cbFunc(); return false; }
	return true;				
}
*/
/*
Check name validation

Input:
maxLength	->	Number		[Number] (max name length, default 15)

Output:
bolean		->	confirm is ok
*/
String.prototype.validationName = function(maxLength)
{
	//if(!this instanceof String){ /*alert("Error: invalid instance, not a String, in validationName() function");*/ return false; }
	maxLength = maxLength || 15;
	if(/*this == "" || this == " " ||*/ /[^a-zA-Z0-9'_ ]/.test(this) || this.length > 15){ return false; }
	return true;
};
/*
String.prototype.validationLength = function(maxLength)
{
	//if(!this instanceof String){ return false; }
	maxLength = maxLength || 15;
	if(this.length > 15){ return false; }
	return true;
}
*/
/*############
### Number ###
############*/

/*
Adapt units of measurement.
Divided a number 

Input:
unit				-> String with unit of measure (W as watt) [optional]

Output:
object
	object.val		->	Scaled value
	object.prefix	->	Char prefix (eg. k = kilo, M = mega, G = giga)
	object.scale	->	Number scale
	object.mixed	->	String value linked with prefix and measure

Number.prototype.scaleMeasure = function(iUnit)
{	
	var oReturn = new Object();
	var value = parseFloat(this);
	iUnit = iUnit || "";
	
	if(isNaN(value)){ alert("Error: value is not a number! [scaleMeasure -> common_methods.js]"); return; }
	
	//Not scaled
	oReturn.val		= value;
	oReturn.prefix	= "";
	oReturn.scale	= 1;
	oReturn.mixed	= value +" "+ iUnit;
	//Kilo
	if(value > 1000){
		value = value * 0.001;
		oReturn.val		= value;
		oReturn.prefix	= "k";
		oReturn.scale	= oReturn.scale * 1000;
		oReturn.mixed	= value +" k"+ iUnit;
	}
	//Mega
	if(value > 1000){
		value = value * 0.001;
		oReturn.val		= value;
		oReturn.prefix	= "M";
		oReturn.scale	= oReturn.scale * 1000;
		oReturn.mixed	= value +" M"+ iUnit;
	}
	//Giga
	if(value > 1000){
		value = value * 0.001;
		oReturn.val		= value;
		oReturn.prefix	= "G";
		oReturn.scale	= oReturn.scale * 1000;
		oReturn.mixed	= value +" G"+ iUnit;
	}
	if(value > 1000){ alert("Add Tera prefix [scaleMeasure -> common_methods.js]"); }
	
	return oReturn;
}*/

/*
Percentual check

Output:
bolean		->	confirm is ok

Number.prototype.isPerCent = function()
{
	if(this != undefined && this != null && this >= 0 && this <= 100){ return true; }
	else{ return false; }
}
*/
/*
Address range check

Output:
bolean		->	confirm is ok

Number.prototype.checkIpSegment = function()
{
	if(this != undefined && this != null && this > 0 && this <= 254){ return true; }
	else{ return false; }
}*/

/*
Round number

Input:
digit		->	number of digits after comma	[integer]	(default is 2)

Output:
float		->	rounded value 

Number.prototype.roundDigits = function(digit)
{
	if(this != undefined){
		var digit = digit || 2,			//Two digits default
			pwr = Math.pow(10,digit),
			a = this;
		a = (parseInt(this * pwr,10))/pwr;
		return a;
	}
}*/

/*
Number added function formatMoney();

Inputs:
c			->	decima digits number	[long, int]
d			->	decimal separator		[char]
t			->	thousand separator		[char]

Output:
String		->	number format
*/
Number.prototype.formatMoney = function(c,d,t)
{
	var n = this,
		c = isNaN(c = Math.abs(c)) ? 2 : c,
		d = d == undefined ? "," : d,
		t = t == undefined ? "." : t,			
		s = n < 0 ? "-" : "",									//Negative value ("-" char to begin of the string)
		i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "",
		j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
};

/*Press only number*/
function validate(evt)
{
	var theEvent = evt || window.event;
	var key = theEvent.keyCode || theEvent.which;
	key = String.fromCharCode( key );
	//Add also minus char
	//var regex = /[0-9]|\./;
	var regex = /[0-9]|\.|\-/;
	
	if(!regex.test(key)){
		theEvent.returnValue = false;
		if(theEvent.preventDefault) theEvent.preventDefault();
	}
}

/*##########
### Date ###
##########*/

Date.prototype.getStrMonth = function()
{
	if(!this instanceof Date){ alert("Error: input element is not a Date object.\ngetStrMonth() function"); return; }
	var numMonth = parseInt(this.getMonth());
	switch(numMonth){
		case 0: return "Jan"; break;
		case 1: return "Feb"; break;
		case 2: return "Mar"; break;
		case 3: return "Apr"; break;
		case 4: return "May"; break;
		case 5: return "Jun"; break;
		case 6: return "Jul"; break;
		case 7: return "Aug"; break;
		case 8: return "Sep"; break;
		case 9: return "Oct"; break;
		case 10: return "Nov"; break;
		case 11: return "Dec"; break;
	}
};


/*###########
### Array ###
###########*/

/*
Return the sum of all array elements (if number)

Array.prototype.sumElements = function()
{
	if(!this instanceof Array){ return false; }			//Check is array
	var sum = 0;
	for(var i = 0; i < this.length; ++i){
		var curr_val = this[i];
		if(isNaN(curr_val) || curr_val == undefined || curr_val == null){ curr_val = 0; }
		sum += parseFloat(curr_val);
	}
	return sum;
}*/

/*
Return an object. Scale all array elements (kilo, Mega, Giga, etc.)

Array.prototype.scaleMeasure = function(iUnit)
{
	var oReturn = new Object();
	var average = parseFloat(this.average());
	var aTmp = new Array();
	iUnit = iUnit || "";
	
	if(isNaN(average)){ alert("Error: average is not a number! [scaleMeasure -> common_methods.js]"); return; }
	
	//Not scaled
	oReturn.data	= this;
	oReturn.prefix	= "";
	oReturn.scale	= 1;
	oReturn.linkUnit = iUnit;
	//oReturn.mixed	= value +" "+ iUnit;
	
	//Kilo
	if(average > 1000){
		average = average * 0.001;
		aTmp = new Array();
		for(var i = 0; i < oReturn.data.length; ++i){
			aTmp[i] = oReturn.data[i] * 0.001;
		}
		
		oReturn.data		= aTmp;
		oReturn.prefix		= "k";
		oReturn.scale		= oReturn.scale * 1000;
		oReturn.linkUnit	= "k"+ iUnit;
	}
	//Mega
	if(average > 1000){
		average = average * 0.001;
		aTmp = new Array();
		for(var i = 0; i < oReturn.data.length; ++i){
			aTmp[i] = oReturn.data[i] * 0.001;
		}
		
		oReturn.data		= aTmp;
		oReturn.prefix		= "M";
		oReturn.scale		= oReturn.scale * 1000;
		oReturn.linkUnit	= "M"+ iUnit;
	}
	//Giga
	if(average > 1000){
		average = average * 0.001;
		aTmp = new Array();
		for(var i = 0; i < oReturn.data.length; ++i){
			aTmp[i] = oReturn.data[i] * 0.001;
		}
		
		oReturn.data		= aTmp;
		oReturn.prefix		= "G";
		oReturn.scale		= oReturn.scale * 1000;
		oReturn.linkUnit	= "G"+ iUnit;
	}
	if(average > 1000){ alert("Add Tera prefix [scaleMeasure -> common_methods.js]"); }
	
	return oReturn;
}
*/
/*
Return average of all array elements

Array.prototype.average = function()
{
	if(!this instanceof Array){ return 0; }			//Check is array
	var sum = 0;
	for(var i = 0; i < this.length; ++i){
		var curr_val = parseFloat(this[i]);
		if(isNaN(curr_val) || curr_val == undefined || curr_val == null){ curr_val = 0; }
		sum += curr_val;
	}
	return (sum/this.length);
}
*/

/*
Return an array with elements the sum of input two array elements

Array.prototype.arraySum = function(a)
{
	var tmp = new Array();
	if(this.length == a.length){
		if(this.length < 1 && a.length < 1){ tmp = this; }
		else{
			for(var i = 0; i < this.length; ++i){ tmp[i] = this[i] + a[i]; }
		}
	}
	else if(this.length > a.length){
		if(a.length < 1 || !a instanceof Array){ tmp = this; }
		else{
			for(var i = 0; i < this.length; ++i){
				if(a[i] != undefined){ tmp[i] = this[i] + a[i]; }
				else{ tmp[i] = this[i]; }
			}
		}
	}
	else if(a.length > this.length){
		if(this.length < 1 || !this instanceof Array){ tmp = a; }
		else{
			for(var i = 0; i < a.length; ++i){
				if(a[i] != undefined){ tmp[i] = this[i] + a[i]; }
				else{ tmp[i] = a[i]; }
			}
		}
	}
	return tmp;
}*/



//--console.log(Array);