/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();
        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));

        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));

        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");

        //Set gateways
        var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;

            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){

                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cycle

                var oGateway = oNode.getData();                                                     //Get node data (gateway)

                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }

        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));

        //Set enable save last value
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));

        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));


        //Set tag
        $Elem = $componentProperties.find("[eve-manager-id='tag']");

        $Elem.empty();
        var tag = oComponent.getParamVal("tag");
        var aTags = $.getSyncJSON("./declarations/tags.json");

        //Empty data point type item
        for(var i=0; i<aTags.length; ++i){
            var $option = $("<option></option>");
            $option.val(aTags[i].id);
            $option.text(aTags[i].label);
            $Elem.append($option);

            //Select
            if(tag == aTags[i].id){
                $option.prop("selected",true);
            }
        }
        //Set customData
        $Elem = $componentProperties.find("[eve-manager-id='customData']");
        $Elem.prop("value",oComponent.getParamVal("customData"));

        $Elem.empty();
        var tag = oComponent.getParamVal("tag");
        var aTags = $.getSyncJSON("./declarations/tags.json");

        //Empty data point type item
        for(var i=0; i<aTags.length; ++i){
            var $option = $("<option></option>");
            $option.val(aTags[i].id);
            $option.text(aTags[i].label);
            $Elem.append($option);

            //Select
            if(tag == aTags[i].id){
                $option.prop("selected",true);
            }
        }


        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");

        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

        var $container = $("[eve-manager-protocol='gui']");

        var comboParams=([


      /*      {label:"Temperatura attivazione torrini",uid:"gui/setpointtorrini",type:"info"},
            {label:"Consumo luci notte",uid:"gui/consumoLnotte",type:"info"},
            {label:"Consumo luci 2",uid:"gui/consumoL2",type:"info"},
            {label:"Consumo luci 1",uid:"gui/consumoL1",type:"info"},

            {label:"Luci Notturne",uid:"gui/LNotte",type:"switch"},
            {label:"Luci Livello 2",uid:"gui/L2",type:"switch"},
            {label:"Luci Livello 1",uid:"gui/L1",type:"switch"},


            {label:"Settimanale torrini",uid:"gui/settimanale_torrini",type:"weekcalendar"},
            {label:"Settimanale lucernari",uid:"gui/settimanale_lucernari",type:"weekcalendar"},
            {label:"Settimanale luci",uid:"gui/settimanale_luci",type:"weekcalendar"},
            {label:"Annuale generale",uid:"gui/annuale",type:"yearcalendar"},
            {label:"Stato crepuscolare",uid:"gui/stato_crepuscolare",type:"combo"},
            {label:"Stato funzionamenti (automatico/manuale)",uid:"gui/stato_funzionamento",type:"switch,info-text"},
            {label:"Sensore crepuscolare",uid:"gui/crepuscolare",type:"info,tuner"}
*/

        ]);

        /* Components */
        var customInsideData="";
        $Elem = $componentProperties.find("[eve-manager-id='gui/components-list']");
        var aWidgetComponents = oComponent.getParamVal("gui/components-list");
        for(var i=0; i<comboParams.length; ++i){
          //  console.log(comboParams[i]);

            var $label = $('<span>' + comboParams[i].label + '</span>');
            var $select = $('<select></select>');
            var componentType = comboParams[i].type;

            //$label.text( _D( componentType.capitalizeFirst() ) );
            $label.addClass("widget-components");

            //Get all created components
            var aComponent = application.getComponentsByType( componentType );

            //Append select
            //$select.addClass("widget-components");
            $select.attr("eve-manager-id","gui/components");
            $select.attr("onchange","setDropDownParam(this);");
            $select.data("componentType",comboParams[i]);

            $container.prepend($select);
            $container.prepend($label);

            //$container.append("<br class='widget-components' /><br class='widget-components' />");



            $select.append($("<option>None</option>"));


            for(var j=0; j<aComponent.length; ++j){
                var oNode = aComponent[j];
                var oParent = oNode.getParent();
                var oComponentExt = oNode.getData();
                var label = oComponentExt.getParamVal("name");

                //console.log(oParent);
                if(oParent.getData() instanceof Component){
                    label = oParent.getData().getParamVal("name") +" - "+ label;
                }

                //var $option = $("<option>"+ oComponentExt.getParamVal("name") +"</option>");
                var $option = $("<option>"+ label +"</option>");

                $option.val(oComponentExt.UId);
                $option.data("eveManagerNode",oComponentExt);
                $select.append($option);
            }
        }

        $container.prepend('<h5 style="margin-top: 0px;">Components</h5>');

        $Elem = $componentProperties.find("[eve-manager-id='gui/components']");
        var aWidgetComponents = oComponent.getParamVal("gui/components");
        //console.error(aWidgetComponents);
        //console.error(oComponent);

        for(var i=0; i<$Elem.length; ++i){
            var $options = $( $Elem[i] ).find("option");

            //Element is not selected
            if(aWidgetComponents[i] == undefined){
                $( $options[0] ).prop("selected",true);         //Select automatically
                setDropDownParam($Elem[i]);                     //Save automatically

                continue;
            }

            for(var j=0; j<$options.length; ++j){

                var $option = $( $options[j] );
                var key;

                for(var k in aWidgetComponents[i]){
                    key = k;
                    break;
                }

                //console.error($option.val());
                //console.log($option.val());
                if( $option.val() == aWidgetComponents[i][key] ){

                    $option.prop("selected",true);              //Select format
                    //console.error($option.id);
                    break;
                }
            }
        }
        //Disable Gateway
        $("#componentproperties [eve-manager-components='mainframe'] [eve-manager-id='gateway']").prop("disabled",true);



        $Elem = $componentProperties.find("[eve-manager-id='gui/torrini_tempo_riarmo']");
        $Elem.val(oComponent.getParamVal("gui/torrini_tempo_riarmo"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/elenco_componenti']");
        $Elem.val(oComponent.getParamVal("gui/elenco_componenti"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/lamps1']");
        $Elem.val(oComponent.getParamVal("gui/lamps1"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/lamps2']");
        $Elem.val(oComponent.getParamVal("gui/lamps2"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/night_lamps']");
        $Elem.val(oComponent.getParamVal("gui/night_lamps"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/permanenza_chiusura_lucernari']");
        $Elem.val(oComponent.getParamVal("gui/permanenza_chiusura_lucernari"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/riarmo_automatico']");
        $Elem.val(oComponent.getParamVal("gui/riarmo_automatico"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/level1']");
        $Elem.val(oComponent.getParamVal("gui/level1"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/level2']");
        $Elem.val(oComponent.getParamVal("gui/level2"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/level_night']");
        $Elem.val(oComponent.getParamVal("gui/level_night"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/manuale']");
        $Elem.val(oComponent.getParamVal("gui/manuale"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/sensorReleaseTime']");
        $Elem.val(oComponent.getParamVal("gui/sensorReleaseTime"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/torrini_temperatura']");
        $Elem.val(oComponent.getParamVal("gui/torrini_temperatura"));

        updateCustomData(oComponent);
    };
}
catch(err){
    console.error(err);
}
