/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/wait/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        //onInitMainframeComponent(oComponent);
        
        //Set default values
        oComponent.addParamVal("name",_D("Wait")+" "+oComponent.UId);
        
        //Set default icons set
        oComponent.addParamVal("icons", new Array());
        
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -384, y: -640 },
            
            srcId: oDefaultPan["id"],
            size: { h: 128, w: 128 },
            setSize: { h: 2048, w: 2048 }
        });
        
        //Important: mantain original position
        aIcons.push(oIcon_status_0);
        oComponent.addParamVal("viewmodelist",[ {id:0, label:"Classic"},{id:1, label:"Modal"} ]);
        oComponent.addParamVal("EVEUIStyle","onlyMap");

    };
}
catch(err){
    console.error(err);
}
