/** Id generator
 *
 * @class EveIdAssign
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function Indexer(){
	/** This class instance
	 * @private
	 */
	var self = this;
	
	/** Next id
	 * @private
	 * @type Integer
	 * @default 0
	 */
	var m_iNextId = 0;
	
	/** Get last id from string
	 */
	/*var getIdFromString = function(strId){
		//Check string validity
		if(strId.length < 1){ return false; }
		var FIND				=	false,				// Find number
			numbers				=	"1234567890",		// All number string
			indexFirstNumb		=	strId.length - 1,	// Number finder index
			firstPosition;								// Fisrt position number
		while(!FIND && indexFirstNumb > 0){
			if(numbers.indexOf(strId.charAt(indexFirstNumb)) != -1){
				firstPosition	= indexFirstNumb;
				indexFirstNumb	= indexFirstNumb - 1;
			}
			else{ FIND = strId; }
		}
		return parseInt(strId.substring(firstPosition,strId.length),10);
	}*/
	
	/** Get next free id
	 * @returns {Integer} free Id
	 */
	this.getNextFreeId = function(){
		m_iNextId++;
		return m_iNextId;
	};
	
	/** Set Highest Id
	 * @returns {Integer} free Id
	 */
	this.setHighestId = function(iId){
		iId = parseInt(iId,10);

		if(!isNaN(iId)){
			if(iId > m_iNextId){ m_iNextId = iId; }
		}
		else{
			console.warn("Can't set highest Id. Input parameter is not a number");
			//console.error("Fatal error, id is not a number!");
			//alert("Fatal error, id is not a number!");
		}
	};

	this.setId = function(iId){
		iId = parseInt(iId,10);

		if(!isNaN(iId)){
			m_iNextId = iId;
		}
		else{
			console.warn("Can't set highest Id. Input parameter is not a number");
			//console.error("Fatal error, id is not a number!");
			//alert("Fatal error, id is not a number!");
		}
	};
};